--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")

local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r * 0.95, g = playerColor.g * 0.95,b = playerColor.b * 0.95,a = 0.98}
local InkedColorsBorder = {r = playerColor.r * 0.85, g = playerColor.g * 0.85,b = playerColor.b * 0.85,a = 1}

local MoverMiniMap = CreateFrame("Frame","MoverMiniMapDrag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	MoverMiniMap:SetFrameLevel(99)
	MoverMiniMap:SetPoint("TOPRIGHT", UIParent, -25, -40)
	MoverMiniMap:SetFrameStrata("FULLSCREEN_DIALOG")
	MoverMiniMap:SetClampedToScreen(true)
	MoverMiniMap:SetClampRectInsets(0, 0, 0,0)
	
	local MoverMiniMapText  = MoverMiniMap:CreateFontString(nil, "OVERLAY")
	MoverMiniMapText:SetFont("Interface\\Addons\\Inked\\Fonts\\Cooline.TTF", 15, "OUTLINE")
	MoverMiniMapText:SetPoint("CENTER",MoverMiniMap,"CENTER", 0,0); 
	MoverMiniMapText:SetText("")
	
local function UpdateMe()
	if(Inked.db.profile.lockframes == false) then
		if Inked.db.profile.UseMiniMap == true then  
			MoverMiniMap:SetSize(Inked.db.profile.MiniMapSize+10,Inked.db.profile.MiniMapSize+10)
			local point, relativeTo, relativePoint, xOfs, yOfs = MoverMiniMap:GetPoint(n)
				Inked.db.profile.MoverMiniMapX = xOfs
				Inked.db.profile.MoverMiniMapY = yOfs
				Inked.db.profile.MoverMiniMapPoint = point
				MoverMiniMapText:SetText("Mini Map")
		end
		
	end	
end	

	local InkedSettingsFrame = CreateFrame("Frame")	
	InkedSettingsFrame:HookScript("OnUpdate",UpdateMe) 
	
local function CreateMoverBackdrop(frame)
	frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
	insets = {top = -2, left = -2, bottom = -2, right = -2}})
	frame:SetBackdropColor(0,0.55,0.95,0.45)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local function InkedMinimap()
	MinimapBorderTop:Hide()					
	MinimapBorder:Hide()						
		
	MinimapZoomIn:Hide()						
	MinimapZoomOut:Hide()
	if Inked.db.profile.ShowZone == true then  			
		MinimapZoneTextButton:SetParent(Minimap)		
		MinimapZoneTextButton:ClearAllPoints()
		MinimapZoneTextButton:SetPoint("TOP", Minimap, 0, 15)	
		MinimapZoneText:SetSize(250,50)
		MinimapZoneText:SetFont(LSM:Fetch("font", Inked.db.profile.Zonefont), Inked.db.profile.ZoneFontSize,Inked.db.profile.ZoneOutline)	
		MinimapZoneText:SetPoint("TOP", Minimap, 0, 47)
		if Inked.db.profile.ClassZoneColor == true then
			MinimapZoneText:SetTextColor(InkedColors.r,InkedColors.g,InkedColors.b,InkedColors.a)
		elseif Inked.db.profile.ClassZoneColor == false then
			if Inked.db.profile.CustomZoneColor == true then
				MinimapZoneText:SetTextColor(Inked.db.profile.ZoneColorR,Inked.db.profile.ZoneColorG,Inked.db.profile.ZoneColorB,Inked.db.profile.ZoneColorA)
			elseif Inked.db.profile.CustomZoneColor == false then
				MinimapZoneText:SetTextColor(1,1,1,1)
			end
		end		
	elseif  Inked.db.profile.ShowZone == false then
		MinimapZoneText:Hide()
	end	  
	GarrisonLandingPageMinimapButton:SetPoint("TOPLEFT", Minimap, "TOPLEFT", -25, -200)
	
	QueueStatusMinimapButton:SetPoint("TOPLEFT", Minimap, "TOPLEFT", -25, -150)
					
	MinimapNorthTag:ClearAllPoints()
	MinimapNorthTag:SetPoint("TOP", Minimap, 0, 0)
	MinimapNorthTag:SetScale(1.25)
	MinimapNorthTag.SetPoint = function()
	end

	Minimap:SetMaskTexture([=[Interface\CHARACTERFRAME\TempPortraitAlphaMask]=])
	if Inked.db.profile.DisableCustomGraphics == false then
		local MinimapCirlce = CreateFrame("Frame","ButtonEdge",Minimap, BackdropTemplateMixin and "BackdropTemplate")
		MinimapCirlce:SetPoint("CENTER",Minimap,"CENTER",2,2)
		MinimapCirlce:SetSize(Inked.db.profile.MiniMapSize,Inked.db.profile.MiniMapSize)
		MinimapCirlce:SetScale(1.2)

		local MinimapCirlceTex = MinimapCirlce:CreateTexture(nil, "BACKGROUND")
		MinimapCirlceTex:SetAllPoints()
		MinimapCirlceTex:SetTexture("Interface\\AddOns\\Inked\\Graphics\\Backgrounds\\MiniMapCircle2")
		if Inked.db.profile.GraphicsClassColors == true then
			MinimapCirlceTex:SetVertexColor(InkedColors.r,InkedColors.g,InkedColors.b,InkedColors.a)
		elseif Inked.db.profile.GraphicsClassColors == false then
			if Inked.db.profile.GraphicsCustomColors == true then
				MinimapCirlceTex:SetVertexColor(Inked.db.profile.GraphicsColorR,Inked.db.profile.GraphicsColorG,Inked.db.profile.GraphicsColorB,Inked.db.profile.GraphicsColorA)
			elseif Inked.db.profile.GraphicsCustomColors == false then
				MinimapCirlceTex:SetVertexColor(1,1,1,1)
			end
		end
	end	  
	Minimap:ClearAllPoints()
	Minimap:SetSize(Inked.db.profile.MiniMapSize,Inked.db.profile.MiniMapSize)

	MiniMapTracking:SetPoint("TOPLEFT", Minimap, "TOPLEFT", -20, -20)
	MiniMapTrackingButtonBorder:Hide()
	if Inked.db.profile.DisableCustomGraphics == false then
		local MiniMapTrackingCirlce = CreateFrame("Frame","ButtonEdge",MiniMapTrackingButton, BackdropTemplateMixin and "BackdropTemplate")
		MiniMapTrackingCirlce:SetPoint("CENTER",MiniMapTrackingButton,"CENTER",0,0)
		MiniMapTrackingCirlce:SetSize(24,24)
		MiniMapTrackingCirlce:SetScale(1.1)

		local MiniMapTrackingCirlceTex = MiniMapTrackingCirlce:CreateTexture(nil, "BACKGROUND")
		MiniMapTrackingCirlceTex:SetAllPoints()
		MiniMapTrackingCirlceTex:SetTexture("Interface\\AddOns\\Inked\\Graphics\\Backgrounds\\MiniMapCircleSmall2")
		if Inked.db.profile.GraphicsClassColors == true then
			MiniMapTrackingCirlceTex:SetVertexColor(InkedColors.r,InkedColors.g,InkedColors.b,InkedColors.a)
		elseif Inked.db.profile.GraphicsClassColors == false then
			if Inked.db.profile.GraphicsCustomColors == true then
				MiniMapTrackingCirlceTex:SetVertexColor(Inked.db.profile.GraphicsColorR,Inked.db.profile.GraphicsColorG,Inked.db.profile.GraphicsColorB,Inked.db.profile.GraphicsColorA)
			elseif Inked.db.profile.GraphicsCustomColors == false then
				MiniMapTrackingCirlceTex:SetVertexColor(1,1,1,1)
			end
		end
	end
	LoadAddOn('Blizzard_TimeManager')
	local clockFrame, clockTime = TimeManagerClockButton:GetRegions()
	clockFrame:Hide()
	if Inked.db.profile.ShowClock == true then  	
		clockTime:Show()
		clockTime:SetSize(150,150)
		clockTime:SetFont(LSM:Fetch("font", Inked.db.profile.Clockfont), Inked.db.profile.ClockFontSize,Inked.db.profile.ClockOutline)
		if Inked.db.profile.ClassClockColor == true then
			clockTime:SetTextColor(InkedColors.r,InkedColors.g,InkedColors.b,InkedColors.a)
		elseif Inked.db.profile.ClassClockColor == false then
			if Inked.db.profile.CustomClockColor == true then
				clockTime:SetTextColor(Inked.db.profile.ClockColorR,Inked.db.profile.ClockColorG,Inked.db.profile.ClockColorB,Inked.db.profile.ClockColorA)
			elseif Inked.db.profile.CustomClockColor == false then
				clockTime:SetTextColor(1,1,1,1)
			end
		end	
		clockTime:SetScale(1.2)
	elseif Inked.db.profile.ShowClock == false then
		clockTime:Hide()
	end
	TimeManagerClockButton:ClearAllPoints()
	TimeManagerClockButton:SetPoint('TOP', Minimap, 'BOTTOM', 0,-5)
	if Inked.db.profile.DisableCustomGraphics == false then
		MiniMapMailBorder:Hide()
		MiniMapMailFrame:ClearAllPoints()
		MiniMapMailFrame:SetScale(1.7)
		MiniMapMailFrame:SetPoint("topright", Minimap,20, -35)	
		MiniMapMailIcon:SetTexture("Interface\\AddOns\\Inked\\Graphics\\Backgrounds\\InkedMailIcon")
		MiniMapMailIcon:SetVertexColor(InkedColors.r,InkedColors.g,InkedColors.b,InkedColors.a)
		
		MiniMapWorldMapButton:ClearAllPoints()
		MiniMapWorldMapButton:SetPoint("RIGHT", Minimap, 20, -70)
		MiniMapWorldMapButton:SetScale(0.75)
		 local blah1,blah2,blah3 = MiniMapWorldMapButton:GetRegions()
			 blah1:SetTexture("")
			 blah2:SetTexture("")
			 blah3:SetTexture("")
			 
		local MMWMBFrame = CreateFrame("Frame",nil,MiniMapWorldMapButton)
		MMWMBFrame:SetFrameLevel(10)
		MMWMBFrame:SetAllPoints()
		
		local MMWMBFrameFrametex = MMWMBFrame:CreateTexture(nil, "BACKGROUND")
		MMWMBFrameFrametex:SetTexture("Interface\\AddOns\\Inked\\Graphics\\Backgrounds\\AzerothWorldMap")	
		MMWMBFrameFrametex:SetAllPoints()
		
		local MMWMBCirlce = CreateFrame("Frame","ButtonEdge",MMWMBFrame, BackdropTemplateMixin and "BackdropTemplate")
		MMWMBCirlce:SetPoint("CENTER",MMWMBFrame,"CENTER",1,1)
		MMWMBCirlce:SetSize(32,32)
		MMWMBCirlce:SetScale(1.15)

		local MMWMBCirlceTex = MMWMBCirlce:CreateTexture(nil, "BACKGROUND")
		MMWMBCirlceTex:SetAllPoints()
		MMWMBCirlceTex:SetTexture("Interface\\AddOns\\Inked\\Graphics\\Backgrounds\\MiniMapCircleSmall2")
		if Inked.db.profile.GraphicsClassColors == true then
			MMWMBCirlceTex:SetVertexColor(InkedColors.r,InkedColors.g,InkedColors.b,InkedColors.a)
		elseif Inked.db.profile.GraphicsClassColors == false then
			if Inked.db.profile.GraphicsCustomColors == true then
				MMWMBCirlceTex:SetVertexColor(Inked.db.profile.GraphicsColorR,Inked.db.profile.GraphicsColorG,Inked.db.profile.GraphicsColorB,Inked.db.profile.GraphicsColorA)
			elseif Inked.db.profile.GraphicsCustomColors == false then
				MMWMBCirlceTex:SetVertexColor(1,1,1,1)
			end
		end
	end
	Minimap:EnableMouseWheel(true)
	Minimap:SetScript("OnMouseWheel", function(_, zoom)
		if zoom > 0 then
			Minimap_ZoomIn()
		else
			Minimap_ZoomOut()
		end
	end)
	
	if(Inked.db.profile.lockframes == false) then
			MoverMiniMap:ClearAllPoints()
			if Inked.db.profile.MoverMiniMapPoint == nil then
				MoverMiniMap:SetPoint("TOPRIGHT", UIParent,Inked.db.profile.MoverMiniMapX,Inked.db.profile.MoverMiniMapY)
				Minimap:SetPoint("TOPRIGHT", UIParent,Inked.db.profile.MoverMiniMapX,Inked.db.profile.MoverMiniMapY)
			else
				MoverMiniMap:SetPoint(Inked.db.profile.MoverMiniMapPoint, UIParent,Inked.db.profile.MoverMiniMapX,Inked.db.profile.MoverMiniMapY)
				Minimap:SetPoint(Inked.db.profile.MoverMiniMapPoint, UIParent,Inked.db.profile.MoverMiniMapX,Inked.db.profile.MoverMiniMapY)
			end
			CreateMoverBackdrop(MoverMiniMap)
			MoverMiniMap:SetMovable(true)
			MoverMiniMap:EnableMouse(true)
			MoverMiniMap:RegisterForDrag("LeftButton")
			MoverMiniMap:SetScript("OnDragStart", MoverMiniMap.StartMoving)
			MoverMiniMap:SetScript("OnDragStop", MoverMiniMap.StopMovingOrSizing)
			MoverMiniMap:SetUserPlaced(true)

						
		elseif Inked.db.profile.MoverMiniMapPoint == nil then
				MoverMiniMap:SetPoint("TOPRIGHT", UIParent,Inked.db.profile.MoverMiniMapX,Inked.db.profile.MoverMiniMapY)
				Minimap:SetPoint("TOPRIGHT", UIParent,Inked.db.profile.MoverMiniMapX,Inked.db.profile.MoverMiniMapY)
			else
				MoverMiniMap:SetPoint(Inked.db.profile.MoverMiniMapPoint, UIParent,Inked.db.profile.MoverMiniMapX,Inked.db.profile.MoverMiniMapY)
				Minimap:SetPoint(Inked.db.profile.MoverMiniMapPoint, UIParent,Inked.db.profile.MoverMiniMapX,Inked.db.profile.MoverMiniMapY)
		end
end

		local InkedLoginFrame=CreateFrame("Frame")
		InkedLoginFrame:RegisterEvent("PLAYER_LOGIN")	
		InkedLoginFrame:RegisterEvent("CINEMATIC_STOP")
		InkedLoginFrame:SetScript("OnEvent", function(self, event) 
			if Inked.db.profile.UseMiniMap == false then  
				return        
			end	  
			InkedMinimap()			
		end)